Package net.sf.saxon.expr

## Class MultiIterator<T>

- java.lang.Object
- - net.sf.saxon.expr.MultiIterator<T>

- All Implemented Interfaces:
    `java.util.Iterator<T>`

      public class MultiIterator<T>
      extends java.lang.Object
      implements java.util.Iterator<T>

  An iterator that combines the results of a sequence of iterators

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MultiIterator​(java.util.List<java.util.Iterator<T>> array)` | Create an iterator that concatenates a number of supplied iterators

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `hasNext()` | Returns `true` if the iteration has more elements.
    `T` | `next()` | Returns the next element in the iteration.
    `void` | `remove()` | Removes from the underlying collection the last element returned by the iterator (optional operation).

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining`

- - ### Constructor Detail

    - #### MultiIterator

          public MultiIterator​(java.util.List<java.util.Iterator<T>> array)

      Create an iterator that concatenates a number of supplied iterators
      Parameters:
        `array` - the iterators to be concatenated

  - ### Method Detail

    - #### hasNext

          public boolean hasNext()

      Returns `true` if the iteration has more elements. (In other words, returns `true` if `next` would return an element rather than throwing an exception.)
      Specified by:
        `hasNext` in interface `java.util.Iterator<T>`
      Returns:
        `true` if the iterator has more elements.

    - #### next

          public T next()

      Returns the next element in the iteration.
      Specified by:
        `next` in interface `java.util.Iterator<T>`
      Returns:
        the next element in the iteration.
      Throws:
        `java.util.NoSuchElementException` - iteration has no more elements.

    - #### remove

          public void remove()

      Removes from the underlying collection the last element returned by the iterator (optional operation). This method can be called only once per call to `next`. The behavior of an iterator is unspecified if the underlying collection is modified while the iteration is in progress in any way other than by calling this method.
      Specified by:
        `remove` in interface `java.util.Iterator<T>`
      Throws:
        `java.lang.UnsupportedOperationException` - if the `remove` operation is not supported by this Iterator.
        `java.lang.IllegalStateException` - if the `next` method has not yet been called, or the `remove` method has already been called after the last call to the `next` method.